\begin{exercise}{1.7}
Let \(\mathcal{B} \subseteq \mathcal{X}\) a set shattered by \(\HypClass_k\). We have two bounds on \(\card \mathcal{B}\):
\begin{itemize}
  \item \(\exists h_1 \in \HypClass_k\colon  \;\; h_1(x) = 1 \ \forall x \in \mathcal{B} \),
        but since there are \(k\) values in \(\mathcal{X}\) on which \(h_1\) is 1:
        \[
          \#\mathcal{B} \le k
        \]
  \item \(\exists h_0 \in \HypClass_k\colon  \;\; h_0(x) = 0 \ \forall x \in \mathcal{B} \),
        but since there are \(k\) values in \(\mathcal{X}\) on which \(h_0\) is 1:
        \[
          \#{\left(\mathcal{X}\backslash\mathcal{B}\right)} \ge k \implies \#\mathcal{B} \le \#\mathcal{X} - k.
        \]
\end{itemize}
We would like to prove that these inequalities are also sufficient. Let's suppose now that \(\mathcal{B}\) satisfy the limits above. Take \(h_\mathcal{B}\colon \mathcal{B} \to \{0,1\}\) a generic function, and let \(n_1 \coloneqq \#\{x\in\mathcal{B}| h_\mathcal{B}(x) = 1\}\).
First bound tell us \(n_1 \le k\).
We can pick \(\mathcal{N} \subseteq \left(\mathcal{X}\backslash\mathcal{B}\right)\) such that \(\#\mathcal{N} = k-n_1\) since \(\#{\left(\mathcal{X}\backslash\mathcal{B}\right)} \ge k \ge k-n_1\).
Finally, we can define
\[
 h(x) \coloneqq
 \begin{cases}
   h_\mathcal{B}(x) & \text{if \(x \in \mathcal{B}\)} \\
   1                & \text{if \(x \in \mathcal{N}\)} \\
   0                & \text{otherwise}
 \end{cases}.
\]
The number of 1s of \(h\) is \(n_1 + k - n_1 = k\), so \(h \in \HypClass_k\) and we can conclude that \(\HypClass_k\) shatters \(\mathcal{B}\).

In conclusion, the VC-dimension of \(\HypClass_k\) is
\[
  \VCdim{\HypClass_k} = \min\left(k, \#\mathcal{X} - k\right).
\]
\end{exercise}